import { TokenSet } from "openid-client";
import { Account, LoggerInstance, Profile } from "../../..";
import { OAuthConfig } from "../../../providers";
import { InternalOptions } from "../../../lib/types";
import { IncomingRequest, OutgoingResponse } from "../..";
export default function oAuthCallback(params: {
    options: InternalOptions<"oauth">;
    query: IncomingRequest["query"];
    body: IncomingRequest["body"];
    method: IncomingRequest["method"];
    codeVerifier?: string;
}): Promise<GetProfileResult & {
    cookies?: OutgoingResponse["cookies"];
}>;
export interface GetProfileParams {
    profile: Profile;
    tokens: TokenSet;
    provider: OAuthConfig<any>;
    logger: LoggerInstance;
}
export interface GetProfileResult {
    profile: ReturnType<OAuthConfig["profile"]> | null;
    account: Omit<Account, "userId"> | null;
    OAuthProfile: Profile;
}
