"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createState = createState;
exports.getState = getState;

var _crypto = require("crypto");

function createState(options) {
  var _provider$checks;

  const {
    csrfToken,
    logger,
    provider
  } = options;

  if (!((_provider$checks = provider.checks) !== null && _provider$checks !== void 0 && _provider$checks.includes("state"))) {
    return;
  }

  if (!csrfToken) {
    logger.warn("NO_CSRF_TOKEN");
    return;
  }

  const state = (0, _crypto.createHash)("sha256").update(csrfToken).digest("hex");
  logger.debug("OAUTH_CALLBACK_PROTECTION", {
    state,
    csrfToken
  });
  return state;
}

function getState({
  provider,
  csrfToken
}) {
  var _provider$checks2;

  if (provider !== null && provider !== void 0 && (_provider$checks2 = provider.checks) !== null && _provider$checks2 !== void 0 && _provider$checks2.includes("state") && csrfToken) {
    return (0, _crypto.createHash)("sha256").update(csrfToken).digest("hex");
  }
}